#include <stdio.h>
#include <errno.h>
#include <error.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

extern const char *__progname;

int
main (int ac, char **argv)
{
	char *suffix = "", *name, *bin_name, *path;
	const char *version = getenv ("GCC_VERSION");
	const char *use_ccache = getenv ("GCC_USE_CCACHE");

	if (!strcmp (__progname, "gcc_wrapper"))
		error (EXIT_FAILURE, 0, "try gcc instead");

	while (version && *version && isspace(*version))
		version++;

	while (use_ccache && *use_ccache && isspace(*use_ccache))
		use_ccache++;

	if (version && *version)
	{
		if (asprintf (&suffix, "-%s", version) < 0)
			error (EXIT_FAILURE, errno, "asprintf");
	}

	if (asprintf (&name, "%s-%s%s", TARGET, __progname, suffix) < 0)
		error (EXIT_FAILURE, errno, "asprintf");

	if (use_ccache && *use_ccache)
		bin_name = "ccache";
	else
		bin_name = name;

	if (asprintf (&path, "%s/%s", BINDIR, bin_name) < 0)
		error (EXIT_FAILURE, errno, "asprintf");

	argv[0] = name;
	execv (path, argv);
	perror (path);
	return EXIT_FAILURE;
}
